<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><title>Python: module Collatz</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head><body bgcolor="#f0f0f8">

<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="heading">
<tr bgcolor="#7799ee">
<td valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial">&nbsp;<br><big><big><strong>Collatz</strong></big></big></font></td
><td align=right valign=bottom
><font color="#ffffff" face="helvetica, arial"><a href=".">index</a><br><a href="file:/u/ri2744/Documents/collatz/Collatz.py">/u/ri2744/Documents/collatz/Collatz.py</a></font></td></tr></table>
    <p><tt>#!/usr/bin/env&nbsp;python3</tt></p>
<p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#eeaa77">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Functions</strong></big></font></td></tr>
    
<tr><td bgcolor="#eeaa77"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><dl><dt><a name="-collatz_eval"><strong>collatz_eval</strong></a>(i, j)</dt><dd><tt>Better&nbsp;Optimization&nbsp;Solution&nbsp;Approach:<br>
&nbsp;<br>
Initialize&nbsp;hardcoded&nbsp;list&nbsp;of&nbsp;tuples:&nbsp;[(a,x),(b,y),(c,z)]<br>
a,b,c,...&nbsp;is&nbsp;set&nbsp;of&nbsp;multiples&nbsp;of&nbsp;1000&nbsp;starting&nbsp;1000&nbsp;ending&nbsp;1000000<br>
x,y,z,...&nbsp;is&nbsp;max&nbsp;cycle&nbsp;length&nbsp;of&nbsp;range(n-999,&nbsp;n)&nbsp;for&nbsp;each&nbsp;multiple&nbsp;of&nbsp;1000<br>
&nbsp;<br>
Use&nbsp;this&nbsp;as&nbsp;an&nbsp;eager&nbsp;cache&nbsp;for&nbsp;breaking&nbsp;up&nbsp;i,j&nbsp;into&nbsp;sub-ranges<br>
and&nbsp;returning&nbsp;maxes&nbsp;for&nbsp;those&nbsp;ranges<br>
&nbsp;<br>
For&nbsp;brute&nbsp;force&nbsp;computation:<br>
use&nbsp;dictionary&nbsp;cache&nbsp;to&nbsp;store&nbsp;cycle&nbsp;length&nbsp;values&nbsp;for&nbsp;each&nbsp;n<br>
to&nbsp;be&nbsp;reused&nbsp;when&nbsp;calculating&nbsp;cycle&nbsp;lengths</tt></dd></dl>
 <dl><dt><a name="-collatz_eval_simple"><strong>collatz_eval_simple</strong></a>(start, end)</dt><dd><tt>start&nbsp;is&nbsp;beginning&nbsp;of&nbsp;range<br>
end&nbsp;is&nbsp;end&nbsp;of&nbsp;range<br>
&nbsp;<br>
Simple&nbsp;optimization&nbsp;of&nbsp;eval&nbsp;using&nbsp;lazy&nbsp;dictionary&nbsp;cache<br>
Compute&nbsp;individual&nbsp;cycle&nbsp;lengths&nbsp;between&nbsp;start&nbsp;and&nbsp;end&nbsp;and&nbsp;store&nbsp;them&nbsp;to&nbsp;the&nbsp;cache<br>
Call&nbsp;helper&nbsp;function&nbsp;to&nbsp;do&nbsp;the&nbsp;computation&nbsp;and&nbsp;pull&nbsp;from&nbsp;cache&nbsp;in&nbsp;that&nbsp;process</tt></dd></dl>
 <dl><dt><a name="-collatz_find"><strong>collatz_find</strong></a>(n, cache)</dt><dd><tt>Compute&nbsp;cycle&nbsp;length&nbsp;of&nbsp;number&nbsp;n<br>
&nbsp;<br>
n&nbsp;is&nbsp;number&nbsp;for&nbsp;which&nbsp;you&nbsp;compute&nbsp;cycle&nbsp;length<br>
cache&nbsp;is&nbsp;lazy&nbsp;dictionary&nbsp;cache&nbsp;used&nbsp;to&nbsp;speed&nbsp;up&nbsp;computation</tt></dd></dl>
 <dl><dt><a name="-collatz_print"><strong>collatz_print</strong></a>(w, i, j, v)</dt><dd><tt>print&nbsp;three&nbsp;ints<br>
w&nbsp;a&nbsp;writer<br>
i&nbsp;the&nbsp;beginning&nbsp;of&nbsp;the&nbsp;range,&nbsp;inclusive<br>
j&nbsp;the&nbsp;end&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;of&nbsp;the&nbsp;range,&nbsp;inclusive<br>
v&nbsp;the&nbsp;max&nbsp;cycle&nbsp;length</tt></dd></dl>
 <dl><dt><a name="-collatz_read"><strong>collatz_read</strong></a>(s)</dt><dd><tt>read&nbsp;two&nbsp;ints<br>
s&nbsp;a&nbsp;string<br>
return&nbsp;a&nbsp;list&nbsp;of&nbsp;two&nbsp;ints,&nbsp;representing&nbsp;the&nbsp;beginning&nbsp;and&nbsp;end&nbsp;of&nbsp;a&nbsp;range,&nbsp;[i,&nbsp;j]</tt></dd></dl>
 <dl><dt><a name="-collatz_solve"><strong>collatz_solve</strong></a>(r, w)</dt><dd><tt>r&nbsp;a&nbsp;reader<br>
w&nbsp;a&nbsp;writer</tt></dd></dl>
</td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#55aa55">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Data</strong></big></font></td></tr>
    
<tr><td bgcolor="#55aa55"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><strong>cache</strong> = {}<br>
<strong>range_arr</strong> = [(1000, 179), (2000, 182), (3000, 217), (4000, 238), (5000, 215), (6000, 236), (7000, 262), (8000, 252), (9000, 247), (10000, 260), (11000, 268), (12000, 250), (13000, 263), (14000, 276), (15000, 271), (16000, 271), (17000, 266), (18000, 279), (19000, 261), (20000, 274), ...]</td></tr></table>
</body></html>